/********************************************************************************

	GnucNS - Network Simulator
    Copyright (C) 2003 John Marshall

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	For support, questions, comments, etc...
	E-Mail: swabby@c0re.net

********************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using GnucNS.Simulation;

namespace GnucNS.Interface
{
	/// <summary>
	/// Summary description for FormStats.
	/// </summary>
	public class FormStatsGeneral : System.Windows.Forms.Form
	{
		FormMain MainView;


		private System.Windows.Forms.Button ButtonCalculate;
		private System.Windows.Forms.Label LabelNodes;
		private System.Windows.Forms.Label LabelFirewalled;
		private System.Windows.Forms.ProgressBar ProgressCalc;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label LabelLeaves;
		private System.Windows.Forms.Label LabelUltrapeers;
		private System.Windows.Forms.Label LabelAvgUptime;
		private System.Windows.Forms.Label LabelAvgConnections;
		private System.Windows.Forms.Label LabelAvgUsed;
		private System.Windows.Forms.Label LabelAvgLeaves;
		private System.Windows.Forms.Label LabelAvgCapacity;
		private System.Windows.Forms.Label LabelAvgBandwidth;
		private System.Windows.Forms.Label LabelDisconnected;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormStatsGeneral(FormMain parent)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			MainView = parent;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			MainView.StatsGeneralView = null;

			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.LabelAvgUptime = new System.Windows.Forms.Label();
			this.ButtonCalculate = new System.Windows.Forms.Button();
			this.LabelAvgConnections = new System.Windows.Forms.Label();
			this.LabelNodes = new System.Windows.Forms.Label();
			this.LabelFirewalled = new System.Windows.Forms.Label();
			this.ProgressCalc = new System.Windows.Forms.ProgressBar();
			this.label1 = new System.Windows.Forms.Label();
			this.LabelLeaves = new System.Windows.Forms.Label();
			this.LabelUltrapeers = new System.Windows.Forms.Label();
			this.LabelAvgUsed = new System.Windows.Forms.Label();
			this.LabelAvgLeaves = new System.Windows.Forms.Label();
			this.LabelAvgCapacity = new System.Windows.Forms.Label();
			this.LabelAvgBandwidth = new System.Windows.Forms.Label();
			this.LabelDisconnected = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// LabelAvgUptime
			// 
			this.LabelAvgUptime.Location = new System.Drawing.Point(24, 160);
			this.LabelAvgUptime.Name = "LabelAvgUptime";
			this.LabelAvgUptime.Size = new System.Drawing.Size(280, 16);
			this.LabelAvgUptime.TabIndex = 1;
			this.LabelAvgUptime.Text = "Uptime:";
			// 
			// ButtonCalculate
			// 
			this.ButtonCalculate.Location = new System.Drawing.Point(112, 272);
			this.ButtonCalculate.Name = "ButtonCalculate";
			this.ButtonCalculate.TabIndex = 3;
			this.ButtonCalculate.Text = "Update";
			this.ButtonCalculate.Click += new System.EventHandler(this.ButtonCalculate_Click);
			// 
			// LabelAvgConnections
			// 
			this.LabelAvgConnections.Location = new System.Drawing.Point(24, 176);
			this.LabelAvgConnections.Name = "LabelAvgConnections";
			this.LabelAvgConnections.Size = new System.Drawing.Size(280, 16);
			this.LabelAvgConnections.TabIndex = 4;
			this.LabelAvgConnections.Text = "Connections:";
			// 
			// LabelNodes
			// 
			this.LabelNodes.Location = new System.Drawing.Point(16, 24);
			this.LabelNodes.Name = "LabelNodes";
			this.LabelNodes.Size = new System.Drawing.Size(296, 16);
			this.LabelNodes.TabIndex = 5;
			this.LabelNodes.Text = "Nodes:";
			// 
			// LabelFirewalled
			// 
			this.LabelFirewalled.Location = new System.Drawing.Point(16, 40);
			this.LabelFirewalled.Name = "LabelFirewalled";
			this.LabelFirewalled.Size = new System.Drawing.Size(296, 16);
			this.LabelFirewalled.TabIndex = 6;
			this.LabelFirewalled.Text = "Firewalled:";
			// 
			// ProgressCalc
			// 
			this.ProgressCalc.Location = new System.Drawing.Point(0, 296);
			this.ProgressCalc.Name = "ProgressCalc";
			this.ProgressCalc.Size = new System.Drawing.Size(328, 16);
			this.ProgressCalc.TabIndex = 7;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 136);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(160, 16);
			this.label1.TabIndex = 9;
			this.label1.Text = "Ultrapeer Average";
			// 
			// LabelLeaves
			// 
			this.LabelLeaves.Location = new System.Drawing.Point(16, 88);
			this.LabelLeaves.Name = "LabelLeaves";
			this.LabelLeaves.Size = new System.Drawing.Size(296, 16);
			this.LabelLeaves.TabIndex = 11;
			this.LabelLeaves.Text = "Leaves:";
			// 
			// LabelUltrapeers
			// 
			this.LabelUltrapeers.Location = new System.Drawing.Point(16, 72);
			this.LabelUltrapeers.Name = "LabelUltrapeers";
			this.LabelUltrapeers.Size = new System.Drawing.Size(296, 16);
			this.LabelUltrapeers.TabIndex = 10;
			this.LabelUltrapeers.Text = "Ultrapeers:";
			// 
			// LabelAvgUsed
			// 
			this.LabelAvgUsed.Location = new System.Drawing.Point(24, 224);
			this.LabelAvgUsed.Name = "LabelAvgUsed";
			this.LabelAvgUsed.Size = new System.Drawing.Size(280, 16);
			this.LabelAvgUsed.TabIndex = 12;
			this.LabelAvgUsed.Text = "Used Capacity:";
			// 
			// LabelAvgLeaves
			// 
			this.LabelAvgLeaves.Location = new System.Drawing.Point(24, 192);
			this.LabelAvgLeaves.Name = "LabelAvgLeaves";
			this.LabelAvgLeaves.Size = new System.Drawing.Size(280, 16);
			this.LabelAvgLeaves.TabIndex = 13;
			this.LabelAvgLeaves.Text = "Leaves";
			// 
			// LabelAvgCapacity
			// 
			this.LabelAvgCapacity.Location = new System.Drawing.Point(24, 208);
			this.LabelAvgCapacity.Name = "LabelAvgCapacity";
			this.LabelAvgCapacity.Size = new System.Drawing.Size(280, 16);
			this.LabelAvgCapacity.TabIndex = 14;
			this.LabelAvgCapacity.Text = "Capacity:";
			// 
			// LabelAvgBandwidth
			// 
			this.LabelAvgBandwidth.Location = new System.Drawing.Point(24, 240);
			this.LabelAvgBandwidth.Name = "LabelAvgBandwidth";
			this.LabelAvgBandwidth.Size = new System.Drawing.Size(280, 16);
			this.LabelAvgBandwidth.TabIndex = 15;
			this.LabelAvgBandwidth.Text = "Bandwidth:";
			// 
			// LabelDisconnected
			// 
			this.LabelDisconnected.Location = new System.Drawing.Point(16, 104);
			this.LabelDisconnected.Name = "LabelDisconnected";
			this.LabelDisconnected.Size = new System.Drawing.Size(296, 16);
			this.LabelDisconnected.TabIndex = 16;
			this.LabelDisconnected.Text = "Leaves Disconnected:";
			// 
			// FormStatsGeneral
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(322, 311);
			this.Controls.Add(this.LabelDisconnected);
			this.Controls.Add(this.LabelAvgBandwidth);
			this.Controls.Add(this.LabelAvgCapacity);
			this.Controls.Add(this.LabelAvgLeaves);
			this.Controls.Add(this.LabelAvgUsed);
			this.Controls.Add(this.LabelLeaves);
			this.Controls.Add(this.LabelUltrapeers);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.ProgressCalc);
			this.Controls.Add(this.LabelFirewalled);
			this.Controls.Add(this.LabelNodes);
			this.Controls.Add(this.LabelAvgConnections);
			this.Controls.Add(this.ButtonCalculate);
			this.Controls.Add(this.LabelAvgUptime);
			this.Cursor = System.Windows.Forms.Cursors.Default;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "FormStatsGeneral";
			this.Text = "Stats General";
			this.ResumeLayout(false);

		}
		#endregion

		private void ButtonCalculate_Click(object sender, System.EventArgs e)
		{
			SimNetwork testNet = MainView.TestNet;
			SimSetup testSetup = MainView.TestSetup;

			int firewalled = 0;
			int scanned = 0;

			int ultrapeers = 0;
			int leaves = 0;
			int disconnected = 0;

			uint avgUptime = 0;
			int  avgConnects = 0;
			int  avgLeaves = 0;
			int  avgCapacity = 0;
			int  avgUsed = 0;
			int  avgBandwidth = 0;


			Cursor = Cursors.WaitCursor;
			ProgressCalc.Value = 0;

			IDictionaryEnumerator enumNode = testNet.NodeTable.GetEnumerator();
			while( enumNode.MoveNext() )
			{
				SimNode currentNode = (SimNode) enumNode.Value;

				if(currentNode.Firewalled)
					firewalled++;
				
				if( currentNode.ChildMode )
				{
					leaves++;

					if(currentNode.Connections.Count == 0)
						disconnected++;
				}
				else
				{
					ultrapeers++;
				
					avgUptime   += currentNode.NodeAlive;
					avgConnects += currentNode.Connections.Count;
					avgLeaves	+= currentNode.Children.Count;
					avgCapacity += currentNode.LeafCapacity;
					
					if(currentNode.LeafCapacity > 0)
						avgUsed		+= currentNode.Children.Count * 100 / currentNode.LeafCapacity;
					else
						avgUsed += 100;

					avgBandwidth += currentNode.BandwidthUp + currentNode.BandwidthDown;
				}

				scanned++;
				ProgressCalc.Value = scanned * 100 / testNet.NodeTable.Count;
			}

			Cursor = Cursors.Default;

			if( testNet.NodeTable.Count > 0 )
			{
				avgUptime   /= (uint) ultrapeers;
				avgConnects /= ultrapeers;
				avgLeaves	/= ultrapeers;
				avgCapacity /= ultrapeers;
				avgUsed     /= ultrapeers;
				avgBandwidth /= ultrapeers;

			}
			
			LabelNodes.Text = string.Format("Nodes: {0}", testNet.NodeTable.Count);
			LabelFirewalled.Text = string.Format("Firewalled: {0}", firewalled);
			LabelUltrapeers.Text = string.Format("Ultrapeers: {0}", ultrapeers);
			LabelLeaves.Text = string.Format("Leaves: {0}", leaves);
			LabelDisconnected.Text = string.Format("Leaves Disconnected: {0}", disconnected);

			LabelAvgUptime.Text = string.Format("Uptime: {0} Hours, {1} Mins, {2} Secs", avgUptime / 3600, (avgUptime % 3600) / 60, avgUptime % 60);
			LabelAvgConnections.Text = string.Format("Connections: {0}", avgConnects);
			LabelAvgLeaves.Text = string.Format("Leaves: {0}", avgLeaves);
			LabelAvgCapacity.Text = string.Format("Capacity: {0}", avgCapacity);
			LabelAvgUsed.Text = string.Format("Used Capacity: {0}%", avgUsed);
			LabelAvgBandwidth.Text = string.Format("Bandwidth: {0}", avgBandwidth);
		}

	}

	struct NodeLink
	{
		public int NodeID;
		public int LinkID;

		public NodeLink(int nodeID, int linkID)
		{
			NodeID = nodeID;
			LinkID = linkID;
		}

	}
}
