/********************************************************************************

	GnucNS - Network Simulator
    Copyright (C) 2003 John Marshall

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	For support, questions, comments, etc...
	E-Mail: swabby@c0re.net

********************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using GnucNS.Simulation;

namespace GnucNS.Interface
{
	/// <summary>
	/// Summary description for FormStats.
	/// </summary>
	public class FormStatsTraffic : System.Windows.Forms.Form
	{
		FormMain MainView;


		private System.Windows.Forms.Button ButtonCalculate;
		private System.Windows.Forms.ProgressBar ProgressCalc;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label LabelBytesDropped;
		private System.Windows.Forms.Label LabelBytesDown;
		private System.Windows.Forms.Label LabelBytesCollided;
		private System.Windows.Forms.Label LabelBytesUp;
		private System.Windows.Forms.Label LabelPacketQueue;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormStatsTraffic(FormMain parent)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			MainView = parent;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			MainView.StatsTrafficView = null;

			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.LabelBytesDropped = new System.Windows.Forms.Label();
			this.LabelBytesDown = new System.Windows.Forms.Label();
			this.LabelBytesCollided = new System.Windows.Forms.Label();
			this.ButtonCalculate = new System.Windows.Forms.Button();
			this.LabelBytesUp = new System.Windows.Forms.Label();
			this.ProgressCalc = new System.Windows.Forms.ProgressBar();
			this.label1 = new System.Windows.Forms.Label();
			this.LabelPacketQueue = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// LabelBytesDropped
			// 
			this.LabelBytesDropped.Location = new System.Drawing.Point(24, 96);
			this.LabelBytesDropped.Name = "LabelBytesDropped";
			this.LabelBytesDropped.Size = new System.Drawing.Size(288, 23);
			this.LabelBytesDropped.TabIndex = 0;
			this.LabelBytesDropped.Text = "Bytes Dropped:";
			// 
			// LabelBytesDown
			// 
			this.LabelBytesDown.Location = new System.Drawing.Point(24, 72);
			this.LabelBytesDown.Name = "LabelBytesDown";
			this.LabelBytesDown.Size = new System.Drawing.Size(288, 23);
			this.LabelBytesDown.TabIndex = 1;
			this.LabelBytesDown.Text = "Bytes Down:";
			// 
			// LabelBytesCollided
			// 
			this.LabelBytesCollided.Location = new System.Drawing.Point(24, 120);
			this.LabelBytesCollided.Name = "LabelBytesCollided";
			this.LabelBytesCollided.Size = new System.Drawing.Size(288, 24);
			this.LabelBytesCollided.TabIndex = 2;
			this.LabelBytesCollided.Text = "Bytes Collided (wasted):";
			// 
			// ButtonCalculate
			// 
			this.ButtonCalculate.Location = new System.Drawing.Point(120, 176);
			this.ButtonCalculate.Name = "ButtonCalculate";
			this.ButtonCalculate.TabIndex = 3;
			this.ButtonCalculate.Text = "Update";
			this.ButtonCalculate.Click += new System.EventHandler(this.ButtonCalculate_Click);
			// 
			// LabelBytesUp
			// 
			this.LabelBytesUp.Location = new System.Drawing.Point(24, 48);
			this.LabelBytesUp.Name = "LabelBytesUp";
			this.LabelBytesUp.Size = new System.Drawing.Size(288, 23);
			this.LabelBytesUp.TabIndex = 4;
			this.LabelBytesUp.Text = "Bytes Up:";
			// 
			// ProgressCalc
			// 
			this.ProgressCalc.Location = new System.Drawing.Point(0, 200);
			this.ProgressCalc.Name = "ProgressCalc";
			this.ProgressCalc.Size = new System.Drawing.Size(328, 16);
			this.ProgressCalc.TabIndex = 7;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 8;
			this.label1.Text = "Average per Sec";
			// 
			// LabelPacketQueue
			// 
			this.LabelPacketQueue.Location = new System.Drawing.Point(24, 144);
			this.LabelPacketQueue.Name = "LabelPacketQueue";
			this.LabelPacketQueue.Size = new System.Drawing.Size(288, 24);
			this.LabelPacketQueue.TabIndex = 9;
			this.LabelPacketQueue.Text = "Packet Queue:";
			// 
			// FormStatsTraffic
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(322, 215);
			this.Controls.Add(this.LabelPacketQueue);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.ProgressCalc);
			this.Controls.Add(this.LabelBytesUp);
			this.Controls.Add(this.ButtonCalculate);
			this.Controls.Add(this.LabelBytesCollided);
			this.Controls.Add(this.LabelBytesDown);
			this.Controls.Add(this.LabelBytesDropped);
			this.Cursor = System.Windows.Forms.Cursors.Default;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "FormStatsTraffic";
			this.Text = "Stats Traffic";
			this.ResumeLayout(false);

		}
		#endregion

		private void ButtonCalculate_Click(object sender, System.EventArgs e)
		{
			SimNetwork testNet = MainView.TestNet;
			SimSetup testSetup = MainView.TestSetup;

			int scanned = 0;
			int ultrapeers = 0;

			int  avgBytesUp = 0;
			int  avgBytesDown = 0;
			int  avgBytesDropped = 0;
			int  avgBytesCollided = 0;
			int  avgPacketQueue = 0;

			Cursor = Cursors.WaitCursor;
			ProgressCalc.Value = 0;

			IDictionaryEnumerator enumNode = testNet.NodeTable.GetEnumerator();
			while( enumNode.MoveNext() )
			{
				scanned++;
				ProgressCalc.Value = scanned * 100 / testNet.NodeTable.Count;
				
				SimNode currentNode = (SimNode) enumNode.Value;
				
				if( currentNode.ChildMode )
					continue;
				else
					ultrapeers++;

				if(currentNode.LogBytesUp.Count > 0)
					avgBytesUp   += currentNode.TotBytesUp / currentNode.LogBytesUp.Count;
				if(currentNode.LogBytesDown.Count > 0)
					avgBytesDown += currentNode.TotBytesDown / currentNode.LogBytesDown.Count;
				if(currentNode.LogBytesDropped.Count > 0)
					avgBytesDropped  += currentNode.TotBytesDropped / currentNode.LogBytesDropped.Count;
				if(currentNode.LogBytesCollided.Count > 0)
					avgBytesCollided += currentNode.TotBytesCollided / currentNode.LogBytesCollided.Count;
				
				avgPacketQueue += currentNode.PacketQueue.Count;
			}

			Cursor = Cursors.Default;

			if( testNet.NodeTable.Count > 0 )
			{
				avgBytesUp   /= ultrapeers;
				avgBytesDown /= ultrapeers;
				avgBytesDropped  /= ultrapeers;
				avgBytesCollided /= ultrapeers;
				avgPacketQueue /= ultrapeers;
			}
			
			LabelBytesUp.Text = string.Format("Bytes Up: {0}", avgBytesUp);
			LabelBytesDown.Text = string.Format("Bytes Down: {0}", avgBytesDown);
			LabelBytesDropped.Text = string.Format("Bytes Dropped: {0}", avgBytesDropped);
			LabelBytesCollided.Text = string.Format("Bytes Collided (wasted): {0}", avgBytesCollided);
			LabelPacketQueue.Text = string.Format("Packet Queue: {0}", avgPacketQueue);
		}

	}

}
