/********************************************************************************

	GnucNS - Network Simulator
    Copyright (C) 2003 John Marshall

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	For support, questions, comments, etc...
	E-Mail: swabby@c0re.net

********************************************************************************/

using System;

namespace GnucNS.Simulation
{
	/// <summary>
	/// Summary description for SimSetup.
	/// </summary>
	public class SimSetup : ICloneable
	{
		public int StartingNodes     = 1000;
		public int StartingWebCaches = 1;

		public int NetworkTTL		 = 7;
		public int NetworkInflux     = 30;
		public int NetworkOutflux    = 60;
		public int NetworkCapacity   = 1000;
		public int NetworkFirewalled = 40;

		public int  NodeConnectMin		= 4;
		public int  NodeConnectMax		= 6;
		public bool NodeAvoidTriangles	= true;

		public bool TrafficSim = false;
		public int  NodeBandwidthMin  = 1024;
		public int  NodeBandwidthMax  = 32768;
		public int  NodeQueryFreq	  = 60;

		public bool UltrapeerSim  = true;
		public int  NodeLeafMin = 10;
		public int  NodeLeafMax = 60;
		public int  LeafModeConnects  = 1;


		public SimSetup()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		#region ICloneable Members

		public object Clone()
		{
			SimSetup ClonedSetup = (SimSetup) MemberwiseClone();

			return ClonedSetup;
		}

		#endregion
	}
}
