/********************************************************************************

	GnucNS - Network Simulator
    Copyright (C) 2003 John Marshall

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	For support, questions, comments, etc...
	E-Mail: swabby@c0re.net

********************************************************************************/

using System;
using System.Collections;
using System.Drawing;

namespace GnucNS.Simulation
{
	/// <summary>
	/// Summary description for SimWebCache.
	/// </summary>
	public class SimWebCache
	{
		public Point DisplayPos;

		SimNetwork TestNet;

		int CacheID = 0;

		int WebCacheSize	= 10;
		ArrayList HostCache = new ArrayList();


		public SimWebCache(SimNetwork theNetwork, int cacheID)
		{
			TestNet = theNetwork;
			CacheID  = cacheID;
		}

		public void DoRequest(SimNode requester)
		{
			// Give requester cached nodes
			IEnumerator nodeEnum = HostCache.GetEnumerator();
			while ( nodeEnum.MoveNext() )
				requester.UpdateCache( (int) nodeEnum.Current );

			// If internal cache less than max size, add node
			if(HostCache.Count < WebCacheSize && !requester.Firewalled)
				HostCache.Add(requester.NodeID);
		}

		public void DoUpdate(SimNode requester)
		{
			if(HostCache.Count >= WebCacheSize)
				HostCache.RemoveAt(0);

			if( !HostCache.Contains(requester.NodeID))
				HostCache.Add(requester.NodeID);
		}

	}
}
